#include "DisplayLib.hpp"

U8G2_SSD1306_128X64_NONAME_F_HW_I2C u8g2(U8G2_R0, /* reset=*/ U8X8_PIN_NONE);

void DisplayLib::updateDisplay(const char* title, const char* detail) {
    u8g2.clearBuffer();
    u8g2.setFont(u8g2_font_ncenB08_tr);
    u8g2.drawStr(0, 10, title);
    u8g2.setFont(u8g2_font_ncenB08_tr);
    u8g2.drawStr(0, 30, detail);
    u8g2.sendBuffer();
}

void DisplayLib::welcomeScreen() {
    u8g2.clearBuffer();
    u8g2.setFont(u8g2_font_ncenB08_tr);
    u8g2.drawStr(0, 10, "Welcome to");
    u8g2.setFont(u8g2_font_ncenB08_tr);
    u8g2.drawStr(0, 30, "Elbestia");
    u8g2.sendBuffer();
}

void DisplayLib::clearDisplay() {
    u8g2.clearBuffer();
    u8g2.sendBuffer();
}

void DisplayLib::initDisplay() {
    u8g2.begin();
    u8g2.enableUTF8Print();
    u8g2.setFont(u8g2_font_ncenB08_tr);
    u8g2.clearBuffer();
    u8g2.sendBuffer();
}

void DisplayLib::displayError(const char* error) {
    u8g2.clearBuffer();
    u8g2.setFont(u8g2_font_ncenB08_tr);
    u8g2.drawStr(0, 10, "Error:");
    u8g2.setFont(u8g2_font_ncenB08_tr);
    u8g2.drawStr(0, 30, error);
    u8g2.sendBuffer();
}

void DisplayLib::displayMessage(const char* message) {
    u8g2.clearBuffer();
    u8g2.setFont(u8g2_font_ncenB08_tr);
    u8g2.drawStr(0, 10, message);
    u8g2.sendBuffer();
}

void DisplayLib::printMessage(const char* message, int x, int y) {
    u8g2.clearBuffer();
    u8g2.setFont(u8g2_font_ncenB08_tr);
    u8g2.drawStr(x, y, message);
    u8g2.sendBuffer();
}

void DisplayLib::printMessage(const String message, int x, int y) {
    u8g2.clearBuffer();
    u8g2.setFont(u8g2_font_ncenB08_tr);
    u8g2.drawStr(x, y, message.c_str());
}

void DisplayLib::sendBuffer() {
    u8g2.sendBuffer();
}